mode(-1);
// specific part
libname='freefemlib';
CXX_compiler='g++';
// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'builder.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break;
  end
end

tab=code2str(-40);
OLD=getcwd();
if ~MSDOS then // Unix Linux
  if part(DIR,1)<>'/' then DIR=getcwd()+'/'+DIR; end
  MACROS=DIR+'macros/';
  SRC=DIR+'src/';

  // Create Makefile
  u=file('open',SRC+'Makefile','unknown');
  write(u,['SCIDIR = '+SCI ...
      'CXX='+CXX_compiler ...
      'CXXLOCALFLAG = -fPIC -g' ...
      'CXXDEFINED= -DNOMAIN  -DFREEFEM -DF77_UNDERSCORE' ...
      'CXXFLAGS= $(CXXLOCALFLAG)  $(CXXDEFINED) ' ...
      '.SUFFIXES: .cpp .c .lo .o .F' ...
      ' ' ...
      '.cpp.o:' ...
      tab+'$(CXX) $(CXXFLAGS) -c $<' ...
      ' ' ...
      'BAMG =  Mesh2.o MeshDraw.o MeshGeom.o MeshQuad.o MeshRead.o \' ...
      tab+'MeshWrite.o Meshio.o Metric.o QuadTree.o  R2.o SetOfE4.o Xrgraph.o ' ...
      'NDBI2 = BamgFreeFem.o analyse.o fonction.o gestchar.o gibbs.o \' ...
      tab+'graph.o ivarsol.o' ...
      'PDEsolv = cglapl.o convec.o fem.o grid.o vect.o' ...
      'LIBRARY = libfreefem.a' ...
      'OBJSF = freefemfi.o' ...
      'OBJSC = $(BAMG) $(NDBI2) $(PDEsolv)' ...
      'include '+SCI+'/Makefile.incl' ...
      'FFLAGS = $(FC_OPTIONS) -I'+SCI+'/routines' ...
      'all :: $(OBJSF) $(OBJSC)' ...
      tab+'ar r libfreefem.a $(OBJSC)' ...
      'distclean ::' ...
      tab+'$(RM) $(OBJSF) $(OBJSC) libfreefem.a'],'(a)');
  file('close',u);
  cmd_make='make'
else // windows Visual C++
  error('FreeFem has not been yet ported on VC++ ...')
  if part(DIR,2)<>':' then DIR=getcwd()+'\'+DIR; end

  SRC=DIR+'src\';
  u=file('open',SRC+'Makefile','unknown');
  MACROS=DIR+'macros\';
  SCI=strsubst(SCI,'/','\');
  write(u,['SCIDIR1 = '+SCI ...
      'SCIDIR = '+SCI ...
      'DUMPEXTS = '+SCI+'\bin\dumpexts.exe' ...
      'SCIIMPLIB = '+SCI+'\bin\LibScilab.lib' ...
      'LIBRARY = FreeFem.lib' ...
      'BAMG =  Mesh2.obj MeshDraw.obj MeshGeom.obj MeshQuad.obj MeshRead.obj \' ...
      tab+'MeshWrite.obj Meshio.obj Metric.obj QuadTree.obj  R2.obj \' ...
      tab+'SetOfE4.obj Xrgraph.obj ' ...
      'NDBI2 = BamgFreeFem.obj analyse.obj fonction.obj gestchar.obj gibbs.obj \' ...
      tab+'graph.obj ivarsol.obj' ...
      'PDEsolv = cglapl.obj convec.obj fem.obj grid.obj vect.obj' ...
      'OBJSF = freefemfi.obj' ...
      'OBJSC = $(BAMG) $(NDBI2) $(PDEsolv)' ...
      'include '+SCI+'\Makefile.incl.mak' ...
      'CPPFLAGS = $(CC_OPTIONS) -DFREEFEM -DFORDLL -DNOMAIN -fPIC' ...
      'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI+'\routines""' ...
      ' ' ...
      'all :: freefem.dll' ...
      ' ' ...
      'freefem.dll: $(OBJSF) $(OBJSC) ' ...
        tab+'@$(DUMPEXTS) -o ""$*.def"" ""$*.dll"" $**' ...
        tab+'@$(LINKER) $(LINKER_FLAGS) $(OBJSF) $(OBJSC) $(SCIIMPLIB) $(XLIBSBIN)'+ ...
      ' $(TERMCAPLIB) /nologo /dll /out:""$*.dll"" /implib:""$*.ilib"" '+ ...
      '/def:""$*.def""'],'(a)');
  file('close',u);
  cmd_make='nmake /f Makefile';
end
// compile Fortran et C sources in src
chdir(SRC);
disp('Be patient it may take a while!');
unix_s(cmd_make);
chdir(OLD);

//compile sci files if necessary and build lib file
genlib(libname,MACROS);

clear fd err nams DIR libname MACROS genlib SRC OLD cmd_make u

