mode(-1);
// specific part
libname='freefemlib';
CXX_compiler='g++';
// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'builder.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break;
  end
end

tab=code2str(-40);
OLD=getcwd();

DIR='';

if part(DIR,1)<>'/' then DIR=getcwd()+'/'+DIR; end
MACROS=DIR+'macros/';
SRC=DIR+'src/';

// Create Makefile
u=file('open',SRC+'Makefile','unknown');
write(u,['SCIDIR = '+SCI ...
    'CXX=c:\\Cygwin\\bin\\g++.exe' ...
    'AR=c:\\Cygwin\\bin\\g++.exe -shared' ...
    'RM=c:\\Cygwin\\bin\\rm.exe' ...
    'CXXLOCALFLAG = -fPIC -g' ...
    'CXXDEFINED= -DNOMAIN  -DFREEFEM -DF77_UNDERSCORE' ...
    'CXXFLAGS= $(CXXLOCALFLAG)  $(CXXDEFINED) ' ...
    '.SUFFIXES: .cpp .c .lo .o .F' ...
    ' ' ...
    '.cpp.o:' ...
    tab+'$(CXX) $(CXXFLAGS) -c $<' ...
    ' ' ...
    'BAMG =  Mesh2.o MeshDraw.o MeshGeom.o MeshQuad.o MeshRead.o \' ...
    tab+'MeshWrite.o Meshio.o Metric.o QuadTree.o  R2.o SetOfE4.o Xrgraph.o ' ...
    'NDBI2 = BamgFreeFem.o analyse.o fonction.o gestchar.o gibbs.o \' ...
    tab+'graph.o ivarsol.o' ...
    'PDEsolv = cglapl.o convec.o fem.o grid.o vect.o' ...
    'LIBRARY = libfreefem.a' ...
    'OBJSF = freefemfi.o' ...
    'OBJSC = $(BAMG) $(NDBI2) $(PDEsolv)' ...
    'include '+SCI+'/Makefile.incl' ...
    'FFLAGS = $(FC_OPTIONS) -I'+SCI+'/routines' ...
    'all :: $(OBJSF) $(OBJSC)' ...
    tab+'$(AR) -o libfreefem.dll $(OBJSC) -L c:\\Cygwin\\usr\\X11R6\\lib -lX11' ...
    'distclean ::' ...
    tab+'$(RM) $(OBJSF) $(OBJSC) libfreefem.a'],'(a)');
file('close',u);
cmd_make='make'
// compile Fortran et C sources in src
chdir(SRC);
disp('Be patient it may take a while!');
unix_s(cmd_make);
chdir(OLD);

//compile sci files if necessary and build lib file
genlib(libname,MACROS);

clear fd err nams DIR libname MACROS genlib SRC OLD cmd_make u

