mode(-1);
// specific part
libname='freefemlib';
libtitle='FreeFem: Finite element PDE solver';
mess=[libtitle+ ' loaded';'execute ""fem_demo()"" for a demonstration'];

// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'loader.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break;
  end
end
fem_funs = ['ff_exec','ff_problem','ff_end','getffResult','buildMesh','UpdateMesh','getMatrix'];

if ~MSDOS then
  if part(DIR,1)<>'/' then DIR=getcwd()+'/'+DIR; end
  MACROS=DIR+'macros/';
  //load the interface
  addinter(DIR+'src/'+['freefemfi.o','libfreefem.a'], "freefemfi",fem_funs,'C++') 
else 
  if part(DIR,2)<>':' then DIR=getcwd()+'\'+DIR; end
  DIR=strsubst(DIR,'/','\');
  MACROS=DIR+'macros\';
  //load the interface
  addinter(DIR+'src\libfreefem.dll',"freefemfi",fem_funs,'C++');
end
// load the library
execstr(libname+'=lib(""'+MACROS+'"")');
// add the help chapter
write(%io(2),[' ';' ';mess;'execute """" for a demo']);
%helps = [%helps; DIR+'man', libtitle];


clear fd err nams DIR  MACROS libname libtitle mess fem_funs 

