#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <strings.h>
#include "def.h"

void * load_lib(char * argv)
{
    void * lib_handle;

    lib_handle = dlopen(argv,RTLD_NOW);
    if ( lib_handle == (void *) NULL || lib_handle < (void *) 0 )
    {
	perror("error loading library -> ");
	exit(1);
    }
    printf("shared library %s loaded\n", argv);
	
    return lib_handle;
}

int main(int argc, char ** argv)
{
  void * handle = load_lib(argv[1]);
  char ctorname[] = "_GLOBAL_$I$essai";

  void   (*main1)();
  strcpy(ctorname,"main1");
  if ((main1 = (void (*)()) dlsym(handle, ctorname)) == (void *) NULL)
    perror("symbol main1 not found\n"),exit(1);
  else 
    {
      printf("--------- Execution du main c++\n");
      (*main1)();
    }

  /*  handle = load_lib("./libfort.so"); */

  void   (*initf)(char *,int*);
  strcpy(ctorname,"initf_");
  if ((initf = (void (*)(char *,int*)) dlsym(handle, ctorname)) == (void *) NULL)
    perror("symbol initf_ not found\n"),exit(1);
  else 
    {
      char chaine [] = "toto";
      int * len = new int;
      *len = strlen(chaine);
      printf("--------- Subroutine fortran loaded\n");
      (*initf)(chaine,len);
    }
  
  /*  strcpy(ctorname,"_GLOBAL_$D$essai"); */
/*    if ((load_data = (void (*)()) dlsym(handle, ctorname)) == (void *) NULL) */
/*      perror("symbol _ftext not found\n"),exit(1); */
/*    else  */
/*      { */
/*        printf("symbol %s loaded\n",ctorname); */
/*        (*load_data)(); */
/*      } */

  dlclose(handle);

  return 0;
}



