#include <iostream.h>
#include "list.h"

class Point
{
public:
  int x,y;
  Point() {}
  Point(int xx,int yy) : x(xx),y(yy) {}
};

inline bool operator == (const Point & p1, const Point & p2)
{
  return ( (p1.x == p2.x) && (p1.y == p2.y) );
}

inline ostream & operator << (ostream & f, const Point & pt)
{
  f << "x = " << pt.x << '\t' << "y = " << pt.y << endl;
  return f;
}

int main()
{
  List<Point> l;
  Point p1(5,4),p2(10,23),p3(3,-12);
  l.Insert(p1);
  l.Insert(p2);
  l.Insert(p3);
  l.Delete(p2);
  l.Display();
  l.DeleteAll();
  l.Insert(p2);
  l.Display();
}
